package ru.dbotthepony.mc.otm.datagen.tags

import net.minecraft.world.item.Items
import net.minecraft.world.item.Tiers
import ru.dbotthepony.mc.otm.registry.MBlocks
import ru.dbotthepony.mc.otm.registry.MItems
import ru.dbotthepony.mc.otm.registry.MRegistry

fun addTags(tagsProvider: TagsProvider) {
	tagsProvider.items.forge("pistons").add(Items.PISTON)
	tagsProvider.circuits.add("basic", MItems.BASIC_CONTROL_CIRCUIT)
	tagsProvider.circuits.add("advanced", MItems.ADVANCED_CONTROL_CIRCUIT)

	tagsProvider.ingots.add("tritanium", MItems.TRITANIUM_INGOT)

	tagsProvider.plates.add("tritanium", MItems.TRITANIUM_PLATE)
	tagsProvider.plates.add("iron", MItems.IRON_PLATE)

	tagsProvider.ore("tritanium", MBlocks.TRITANIUM_ORE)
	tagsProvider.ore("tritanium", MBlocks.DEEPSLATE_TRITANIUM_ORE)
	tagsProvider.clump("tritanium", MItems.TRITANIUM_ORE_CLUMP, MBlocks.TRITANIUM_RAW_BLOCK)

	tagsProvider.wires.add("copper", MItems.COPPER_WIRING)
	tagsProvider.wires.add("gold", MItems.GOLD_WIRING)

	tagsProvider.requiresPickaxe(
		MBlocks.MATTER_CABLE,
		MBlocks.STORAGE_CABLE
	)

	tagsProvider.requiresPickaxe(listOf(
		MBlocks.ANDROID_STATION,
		MBlocks.BATTERY_BANK,
		MBlocks.MATTER_DECOMPOSER,
		MBlocks.MATTER_CAPACITOR_BANK,
		MBlocks.PATTERN_STORAGE,
		MBlocks.MATTER_SCANNER,
		MBlocks.MATTER_PANEL,
		MBlocks.MATTER_REPLICATOR,
		MBlocks.MATTER_BOTTLER,
		MBlocks.ENERGY_COUNTER,
		MBlocks.CHEMICAL_GENERATOR,
		MBlocks.PLATE_PRESS,
		MBlocks.MATTER_RECYCLER,

		MBlocks.STORAGE_BUS,
		MBlocks.STORAGE_IMPORTER,
		MBlocks.STORAGE_EXPORTER,

		MBlocks.DRIVE_VIEWER,
		MBlocks.DRIVE_RACK,
		MBlocks.ITEM_MONITOR,
		MBlocks.STORAGE_POWER_SUPPLIER,
	), Tiers.IRON)

	tagsProvider.requiresPickaxe(MBlocks.TRITANIUM_ORE, Tiers.IRON)
	tagsProvider.requiresPickaxe(MBlocks.DEEPSLATE_TRITANIUM_ORE, Tiers.IRON)
	tagsProvider.requiresPickaxe(MBlocks.TRITANIUM_RAW_BLOCK, Tiers.IRON)

	tagsProvider.requiresPickaxe(MBlocks.TRITANIUM_STRIPED_BLOCK, Tiers.IRON)
	tagsProvider.requiresPickaxe(MBlocks.CARBON_FIBRE_BLOCK, Tiers.IRON)

	tagsProvider.requiresPickaxe(MRegistry.VENT.blocks, Tiers.IRON)
	tagsProvider.requiresPickaxe(MRegistry.VENT_ALTERNATIVE.blocks, Tiers.IRON)
	tagsProvider.requiresPickaxe(MRegistry.TRITANIUM_BLOCK.blocks, Tiers.IRON)
	tagsProvider.requiresPickaxe(MRegistry.TRITANIUM_STRIPED_BLOCK.blocks, Tiers.IRON)
	tagsProvider.requiresPickaxe(MRegistry.FLOOR_TILES.coloredBlocks)

	tagsProvider.requiresShovel(MRegistry.UNREFINED_FLOOR_TILES.coloredBlocks)

	tagsProvider.requiresPickaxe(MRegistry.INDUSTRIAL_GLASS.blocks, Tiers.STONE)
	tagsProvider.requiresPickaxe(MRegistry.INDUSTRIAL_GLASS_PANE.blocks, Tiers.STONE)
	tagsProvider.requiresPickaxe(MBlocks.CRATE_LIST, Tiers.STONE)

	tagsProvider.requiresPickaxe(listOf(
		MBlocks.GRAVITATION_STABILIZER,
		MBlocks.GRAVITATION_STABILIZER_LENS,
	), Tiers.DIAMOND)

	tagsProvider.dragonImmune.add(
		MBlocks.BLACK_HOLE,
		MBlocks.GRAVITATION_STABILIZER,
		MBlocks.GRAVITATION_STABILIZER_LENS,
	)

	tagsProvider.witherImmune.add(
		MBlocks.BLACK_HOLE,
	)
}
