package ru.dbotthepony.mc.otm.client

import net.minecraft.client.gui.screens.inventory.InventoryScreen
import net.minecraftforge.client.event.MovementInputUpdateEvent
import net.minecraftforge.client.event.ScreenEvent
import ru.dbotthepony.mc.otm.capability.matteryPlayer
import ru.dbotthepony.mc.otm.client.screen.ExoSuitInventoryScreen
import ru.dbotthepony.mc.otm.registry.AndroidFeatures

object ClientEventHandler {
	fun inputEvent(event: MovementInputUpdateEvent) {
		val ply = event.entity
		val input = event.input

		val cap = ply.matteryPlayer ?: return

		if (!cap.isAndroid || cap.hasFeature(AndroidFeatures.AIR_BAGS))
			return

		if (ply.abilities.mayfly) {
			cap.lastJumpTicks = 14
		} else {
			if (ply.isInWater) {
				if (ply.isOnGround) {
					cap.lastJumpTicks = 14
				}

				if (ply.isSwimming) {
					ply.isSwimming = false
				}

				if (cap.lastJumpTicks <= 0) {
					input.jumping = false
					input.up = false
				} else {
					cap.lastJumpTicks--
				}
			}
		}
	}

	fun screenOpen(event: ScreenEvent.Opening) {
		if (minecraft.player?.isCreative == true) {
			return
		}

		val player = minecraft.player?.matteryPlayer ?: return

		if (player.hasExoSuit && event.newScreen is InventoryScreen) {
			event.newScreen = ExoSuitInventoryScreen(player.exoSuitMenu)
		}
	}
}
