package ru.dbotthepony.mc.otm.client.screen.panels

import net.minecraft.network.chat.Component
import ru.dbotthepony.mc.otm.core.TextComponent
import ru.dbotthepony.mc.otm.client.screen.MatteryScreen
import ru.dbotthepony.mc.otm.menu.widget.NumberPlayerInputWidget
import java.math.BigDecimal

open class NumberInputPanel(
	screen: MatteryScreen<*>,
	parent: EditablePanel?,
	val inputWidget: NumberPlayerInputWidget,
	x: Float = 0f,
	y: Float = 0f,
	width: Float = 0f,
	height: Float = 20f,
	defaultText: Component = TextComponent("")
) : EditBoxPanel(screen, parent, x, y, width, height, defaultText) {
	protected var nextUpdateFromServer = 0L
	protected var inputStr = ""

	override fun tick() {
		super.tick()

		if (isFocused) {
			nextUpdateFromServer = System.currentTimeMillis() + 2000L
		}

		if (nextUpdateFromServer < System.currentTimeMillis()) {
			getOrCreateWidget().value = inputWidget.value.toPlainString()
			inputStr = getOrCreateWidget().value
		} else {
			if (inputStr != getOrCreateWidget().value) {
				inputStr = getOrCreateWidget().value

				try {
					inputWidget.userInput(BigDecimal(inputStr))
				} catch (_: Throwable) { }
			}
		}
	}
}
